<?php

class CpeshippingFileModel {
  public $file_id;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;

  private static $SqlOptions = ["orderBy" => "id"];
  
  public static function create(Array $data) {
    $model = new CpeshippingFile();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model ->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("CpeshippingFile", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new CpeshippingFile($data);
    }
    return $item;
  }
  
  public static function getFirst($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("CpeshippingFile", "*", "$where ORDER BY id");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new CpeshippingFile($data);
      if($item->id) {
        return $item;
      } else {
        return null;
      }
    }
    return null;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("CpeshippingFile", "*", "1=1 ORDER BY id");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new CpeshippingFile($data);
      }
    }
    return $items;
    
  }
  
  
  public static function count($filter) {
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $sql = "SELECT COUNT(*) as cnt FROM CpeshippingFile WHERE $where";
    
    $res = $db->query($sql);
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      return $data->cnt;
    }
    return 0;
  }
  
  public static function search($filter, $limit = false) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $sqlOptions = self::$SqlOptions;
    
    if(array_key_exists("SqlOptions", $filter) && is_array($filter['SqlOptions']) && count($filter['SqlOptions'])) {
      if(array_key_exists("orderBy", $filter['SqlOptions'])) {
        $SqlOptions["orderBy"] = $filter['SqlOptions']['orderBy'];
      }
    }
    $sql = "SELECT * FROM CpeshippingFile WHERE $where ORDER BY ".$SqlOptions["orderBy"];
    
    if(is_array($limit) && count($limit)) {
      if(is_numeric($limit['start']) && is_numeric($limit['count'])) {
        $sql .= " LIMIT ".$limit['start'].", ".$limit['count'];
      } elseif(is_numeric($count)) {
        $sql .= " LIMIT ".$limit['count'];
      }
    }
    
    $res = $db->query($sql);
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new CpeshippingFile($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    if(array_key_exists("file_id", $filter)) {
      $file_id = $filter['file_id'];
      if(is_numeric($file_id)) {
        $where .= " AND file_id=$file_id";
      }
    }

    return $where;
  }
  
}
